/* gamemain2.c */
#include<scenario.h>
#include<screen.h>
#include<gameio.h>
#include<walls.h>
#include<stdio.h>
#include<enemy.h>
#include<stdlib.h>
#include<time.h>
#include<movingobjectmanager.h>
#include<ncurses.h>
#include<string.h>

#ifdef DEBUG
#include<log.h>
#endif

#define OBJNUM 3
#define MOBJNUM 6
#define EVNUM 6
#define LIFE 3
int score=0;

object* objp[OBJNUM];
movingobject* mobjp[MOBJNUM];
event* ev[250];
vector2 mypos;
int isfire;
int score;

void onestepb(movingobject* mobj){
  vec2add(&(mobj->pos), &(mobj->vel));/*進む*/
}

void dispb(movingobject* mobj){
  putobject(*(mobj->obj), mobj->id, mobj->pos.x, mobj->pos.y);
  /*dispbufferとcheckbufferにmobjの情報を入力*/}

void dispm(movingobject* mobj){
  putobject(*(mobj->obj), 0, mobj->pos.x, mobj->pos.y);
  /*特にcheckbufferに0入力*/
}

int bomba(movingobject* mobj){
  return 1;
}

void initobjects(void){
  objp[0] = newobject(1,1,"x");
  objp[1] = newobject(3,2," ^ =x=");
}

void initmovingobjects(void){
  mobjp[0] = newenemy();
  mobjp[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
  mobjp[3] = newdenemy();
  mobjp[4] = newdbeam();
  mobjp[5] = newenemyuchihashi(); 
}
static int Time=0;
static int l=0;
void setevents(void){
  int i=0,t,k;

    k=rand();
    ev[0] = newevent((3+l*130), makevector2(k%40,2),makevector2(0,0.1), mobjp[0],"plus0");
    ev[1] = newevent((20+l*130), makevector2(k%29,2),makevector2(0,0.1), mobjp[0],"plus1");
    ev[2] = newevent((45+l*130), makevector2(k%18,5),makevector2(0,0.1), mobjp[5],"plus2");
  t=k%40;
  ev[3] = newevent((70+l*130), makevector2(t,2),makevector2(0,0.1), mobjp[3],"plus3");
  ev[4] = newevent((70+l*130), makevector2(t,2),makevector2(0,0.80), mobjp[4],"plus4");
  ev[5] = newevent((105+l*130), 
                   makevector2(t,2),makevector2(0,0.80), mobjp[4],"dummy");
  for(i=l;i<EVNUM;i++){
    addevent(ev[i]);
  }
  l++;
  resetmark();/*markを0にする*/
}


void init(void){
  initscreen();/*dispbuffer checkbufferの縦横分の容量確保*/
  initwalls();/* walldataをチェックし背景のどこが壁なのかを調べcollisioncheckdataに収納*/
  initmom();/* movingobjectmanagerのobjlistの容量確保*/
  initobjects(); /*gamemain2のobjp初出　enemy.cのobjp[0]の１行１列目にx　objp[1]の３行２列目左下として^ =x=をセット */
  initmovingobjects();/*mobjp初出　mobjp[0] enemy.cの*objpに敵ビジュアル 
			　　　　　　7待ち17動く　12おきにビジュアル変更　checkbufferに情報 dispbuffer 0とかそういう奴　発砲許可
		      　　　　　　mobjp[1]銃弾進む
		      　　　　　　mobjp[2]*/
  initscenario();/*mark=0*/
  setevents();/**/
}
 /*
	 mobjp[0]にenemyという名前で3行目３列を頂点として : ::: : をmobjp[1]にmobjp[2]
	 mobjp.objに銃弾と自分のデータを上書き
	 scenarioの容量を確保　mark=0
	 敵情報をev[ ].objに代入*/

void getstate(vector2* ret, int* isfire){
  static vector2 pos = {SCREENWIDTH/2-1, SCREENHEIGHT-3}; 
  *isfire = 0;
  int in = gameioread();/*キーボードから一文字読み取る*/
  switch(in){
  case KEY_RIGHT:
    pos.x++;
    break;
  case KEY_LEFT:
    pos.x--;
    break;
  case KEY_UP:
    pos.y--;
    break;
  case KEY_DOWN:
    pos.y++;
    break;
  case ' ':
    *isfire = 1;
  } 
  *ret = pos;
}

void show(void){
  int x,y;
  for(y=0;y<SCREENHEIGHT;y++){
    for(x=0;x<SCREENWIDTH;x++){
      gameioput(x,y,dispbuffer[SCREENWIDTH*y+x]);
    }
  }
  gameiorefresh();
}

void gameloop(void){
  int speedlevel = 8; 
  speedlevel+=Time/1000;
  int life=speedlevel*LIFE;
  int i,k;
  vector2 tmpv;
  event*ev;
  event* e = getnextevent();/*次のイベントeに移動*/
  for(i=0;i<(life/speedlevel);i++){
   gameioput(SCREENWIDTH+LIFE+i,3,'@');
  }
  while(1){
    if(e==NULL){initscenario();setevents();e = getnextevent();}
    gameiousleep(30000);/*30000タイム待つ*/
    if(Time%speedlevel == 0){
      scrollwall();/*1進む*//*MAX25*/

      while(e!= NULL && e->time*speedlevel< Time){/*いじるイベントが存在したら*/
        addmo(e->mobj, e->pos, e->vel);/*e->mobjにposvel代入して objlistに追加count++*/
        e = getnextevent();/*次のイベントに移動*/
      }
      /*if(e==NULL){initscenario();
	setevents();}*/
     
      score++;/*score++*/
    }

getstate(&mypos, &isfire);/*キーボード入力に従ってmypos.x,y変更*/
gameioput(SCREENWIDTH+3,1,'0'+(int)mypos.x/10);
gameioput(SCREENWIDTH+4,1,'0'+(int)mypos.x%10);
gameioput(SCREENWIDTH+6,1,'0'+(int)mypos.y/10);
gameioput(SCREENWIDTH+7,1,'0'+(int)mypos.y%10);
 for(i=0;i<(3-life/8+1);i++){
   gameioput(SCREENWIDTH+6-i,3,' ');
}
 gameioput(SCREENWIDTH+8,3,'0'+(int)life/8);

gameioput(SCREENWIDTH+3,38,'0'+(int)score/1000);
 gameioput(SCREENWIDTH+4,38,'0'+(int)((score%1000)/100));
 gameioput(SCREENWIDTH+5,38,'0'+(int)((score%1000%100)/10));
 gameioput(SCREENWIDTH+6,38,'0'+(int)(score%1000%100%10));





 if(score>=10000)break;
    putwalls(SCREENHEIGHT);
    putmo();
    onestepmo();
    if(checkcollision(mypos, objp[1])!=NONOBJ){
      if(life<=8)break;
      life--;
    
    }
if(isfire){/*isfireが１なら*/
tmpv = mypos;/*弾の位置を自分の位置にする*/
      tmpv.x +=1;
      tmpv.y -=2;
addmo(mobjp[1], tmpv, makevector2(0,-1));/*objリストに弾を追加*/
    }
    mobjp[2]->pos = mypos;
    dispm(mobjp[2]);
show();/*すべて表示*/
Time++;/*1タイム経過*/
  }
}

int main(void){
  srand((unsigned)time(NULL));
  gameioinit();/*停止時のシチュエーション設定・端末の初期化・getchをいつでも受け入れられる状態にセット・キーの入力をraw modeにして、キー入力がバッファされずすぐにプログラムに渡され、打った文字がスクリーンにエコーしないようにする*/

  gameioclear();/*clearokを呼び出し、次のrefreshの呼び出し時に画面全体を再描画する*/

  init();/*dispbuffer checkbufferの縦横分の容量確保
	  walldataをチェックし背景のどこが壁なのかを調べcollisioncheckdataに収納
	  objlistの容量確保
	 objp[0]の１行１列目にx　objp[1]の３行２列目左下として^ =x=をセット 
	 mobjp[0]にenemyという名前で3行目３列を頂点として : ::: : をmobjp[1]にmobjp[2]
	 mobjp.objに銃弾と自分のデータを上書き
	 scenarioの容量を確保　mark=0
	 敵情報をev[ ].objに代入
scenarioに入力*/
  score=0;
  gameloop();/*speedlevel=8
	       30000待つ
	     8回の処理に一回進む
	     最初の24回の処理まではev[0]を採用120回までは・・・
	     読み込んだ文字に従って処理　銃とぶつかったら終わり*/
  
  gameiopost();
  if(score<9999){
  printf("score %d\n",score);
  }
  else{printf("GAME CLEAR!!\n");}
  return 0;
}
